Page MenuHomePhabricator

TemplateStyles style guidance outreach
Closed, ResolvedPublic

Description

Background

As we deploy TemplateStyles to communities, make sure relevant editors on the wikis have a decent chance to learn about TemplateStyles.

TemplateStyles will store CSS in templates on a separate page.

This way, styles in stylesheets can be referred to by several templates. Small templates are not styled well for mobile, which is a problem given the number of readers who come from mobile. This will make it easier to have different styles for mobile and desktop. We should also have an ongoing conversation with the communities as to what can, within reason, be done with style sheets. Is there anything they'd like to do that can't that we could do with this?

Reading wants CL support for this. Template editors should be aware of what's happening and understand why we consider it important, our templates have mobile-friendly styles (not necessarily the same as for desktop), and template editors should know how to do different styles for desktop and mobile, which we should make as easy as possible for them.

Success criteria
As the feature is deployed we work with communities to build awareness and contributors feel empowered to use the feature to improve the readability of content.

As suggested in T164927#3726517,

"Assuming everything goes as anticipated, to build awareness, I'll post announcements to the appropriate talk pages (Village Pumps) and mailing lists to let contributors know of the new feature, reference documentation, and let folks know where to get help.

Additionally, it's recommended that as we work with the communities to enable this feature we use something like a notice on the Template namespace (English Wikipedia example) for a few weeks after enabling the feature to let logged-in contributors know of the feature - in case they miss the initial announcement. This is something I'm happy to help draft, but when possible would love to have community support for enabling."

For communities we approach in the initial phases of deployment:

  • Make sure we get community consensus before deploying
  • Once consensus is obtained, post an announcement of the feature to the local Village Pump (Technical)
    • Reach out to the maintainers of popular templates (use Special:MostTranscludedPages for assistance on a per-project basis to determine popular templates)
    • Reach out to the maintainers of Main Pages
    • Reach out to any mobile-interested users (via knowledge of interested parties in past VP/Phabricator discussions)
  • Receive any feedback and address questions
  • Update documentation if necessary

Timeline
No specific timeline. Could continue through the WMF fiscal year of 2017/2018, but the sooner the better.

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Restricted Application added a project: User-Johan. · View Herald TranscriptMay 10 2017, 12:39 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
Anomie added a subscriber: Anomie.Jun 7 2017, 4:15 PM

Hi @Johan, we're getting close to loading this on the beta cluster (<lang>[.m].<project>.beta.wmflabs.org) and I wanted to give a heads up that we'll be interested in (re)starting outreach. A couple of tangible things we were considering, was curious about your thoughts:

  • Would it make sense to identify a small wiki or two with a couple editors who might be interested in trying this first in production? We anticipate we should be able to ship to the wikis in general, but did want to smoketest in prod on a wiki or two and work out any obvious issues there with interested people.
  • @JKatzWMF and @Nirzar (and maybe @Tgr or another engineer or both) will likely be the ones working out more user-facing documentation on writing mobile friendly styles for templates using this new tech, beyond the basic examples. They also will likely have some additional outreach and possibly a re-assembling of a working group. I won't be as involved as we start shifting into this phase of the project.

I'll make a comment in the other ticket around the guidance (T164879: TemplateStyles style guidance) about this ticket for anyone scrolling through the history later on.

Johan added a comment.Jun 7 2017, 11:34 PM

Would it make sense to identify a small wiki or two with a couple editors who might be interested in trying this first in production? We anticipate we should be able to ship to the wikis in general, but did want to smoketest in prod on a wiki or two and work out any obvious issues there with interested people.

This is very rarely a bad idea. (:

FYI, TemplateStyles is now live in Beta Labs. See, for example, https://en.wikipedia.beta.wmflabs.org/wiki/TemplateStylesTest.

Johan raised the priority of this task from Low to Normal.Jun 25 2017, 10:53 PM

Hi @Johan, we're getting close to loading this on the beta cluster (<lang>[.m].<project>.beta.wmflabs.org) and I wanted to give a heads up that we'll be interested in (re)starting outreach. A couple of tangible things we were considering, was curious about your thoughts:

  • Would it make sense to identify a small wiki or two with a couple editors who might be interested in trying this first in production? We anticipate we should be able to ship to the wikis in general, but did want to smoketest in prod on a wiki or two and work out any obvious issues there with interested people.
  • @JKatzWMF and @Nirzar (and maybe @Tgr or another engineer or both) will likely be the ones working out more user-facing documentation on writing mobile friendly styles for templates using this new tech, beyond the basic examples. They also will likely have some additional outreach and possibly a re-assembling of a working group. I won't be as involved as we start shifting into this phase of the project.

Any CLs will need such documentation in place before being able to evaluate further. Has this work started anywhere?
@Tgr, @Anomie, your extensive community experience begs a question: let's start with huwp and enwp? ;)

I'll make a comment in the other ticket around the guidance (T164879: TemplateStyles style guidance) about this ticket for anyone scrolling through the history later on.

Anomie added a subscriber: bd808.Jun 26 2017, 2:46 PM

@Tgr, @Anomie, your extensive community experience begs a question: let's start with huwp and enwp? ;)

As much as I think it would be a very good place to get feedback, since there are many active editors there experienced in CSS, enwiki tends to hate being a testbed. If we want to use enwiki as a test, we'll need to first ask on the Village pump there (probably the 'technical' section, and post notices of the discussion in the 'proposals' section, at the Administrators' noticeboard, and MediaWiki talk:Common.css) and accept it if they say "no". I'll be happy to help draft the request and handle responses.

@bd808 mentioned wanting it on wikitech. mediawiki.org might also be a decent place for testing. In both cases, though, I don't know that the community size/activity is sufficient to get good feedback.

Johan added a comment.Jun 26 2017, 3:10 PM

It all depends on how big a community we want. I've been thinking mid-sized wikis, which would give us a couple of first rather intimate discussions given that they'll most likely just have a couple of template editors at this level.

Qgil updated the task description. (Show Details)Jun 27 2017, 8:10 AM
Johan updated the task description. (Show Details)Jun 27 2017, 11:56 AM

I defer to @Johan and @JKatzWMF on community outreach for the content sites.

Regarding wikimedia.wikitech.org (@bd808 suggestion), mediawiki.org (@Anomie suggestion), and maybe wikimediafoundation.org (wouldn't it be nice to style the home page and org chart?), @JKatzWMF any interest in us deploying there, even if not doing outreach? What do you think about outreach in those areas?

bd808 added a comment.Jun 27 2017, 5:31 PM

On wikitech I would like to use the extension to replace the .deploycal* and .mw-tpl-portal* styles we have in https://wikitech.wikimedia.org/wiki/MediaWiki:Common.css. It may also be useful for future documentation beautification work on that wiki.

(FYI the WMF wiki is possibly not worth working on much ATM, since Comms is actively working on deciding what to do about that site.)

Johan added a comment.Jun 28 2017, 1:56 PM

If part of the point here is to start having conversations with template editors who edit templates that will be used by the non-technical editor community, I'm not sure mediawiki.org or Wikitech will take us in that direction. That's not an argument for not doing them as soon as possible if there's reason to, but they're not exactly the same kind of environment as the typical Wikimedia wiki.

@Elitre good point, I remember hearing about that, but don't recall the particulars.

@Johan, agreed. I think for our internal and engineering community purposes it would be nice to afford this option on mediawiki.org and wikitech.wikimedia.org as a number of users on these wikis spend lots of time in CSS land and would probably enjoy the opportunity to work on the technology on a production internet facing site a tad earlier.

Tgr added a comment.Jun 28 2017, 3:55 PM

@Tgr, @Anomie, your extensive community experience begs a question: let's start with huwp and enwp? ;)

Huwiki is generally open to testing new things so I don't think I would have any problem getting consensus; I am less sure if there would be anyone willing to spend a lot of time converting templates. Without someone actively testing, there is not too much point in enabling it early. I'll ask around.

Enwiki has a much larger template maintainer community so it would no doubt provide great feedback. OTOH part of the reason of starting with smaller wikis is to find out what kind of anti-abuse (or even anti-accidental-misuse) features are needed, and limit potential trouble until that happens, so testing on enwiki is somewhat risky IMO.

Johan added a comment.Jun 28 2017, 3:55 PM

@dr0ptp4kt Would be a potential way to do it, of course. If so, just to make sure we're on the same page, do we do something like this?

First step: mediawiki.org and Wikitech (I don't think the WMF wiki is a good idea, mainly because of what @Elitre pointed out above). Not a lot of outreach necessary. Mention it in the right IRC-channels, email to wikitech-l, more that level. Do this soon. Iron out any obvious problems.

Second step: A couple of mid-sized wikis (e.g. Hungarian Wikipedia, as suggested by @Elitre above if @Tgr thinks its a good idea). We mention it in the right local channels on the wikis, but concentrate on talking to active template editors.

Unless someone turns up and says "hey, I want that on my wiki" in case there's probably (with a few exceptions, e.g. maybe not the largest wikis first) good reason to let them have it on their wiki, as this will work much better if it's being driven by someone locally with our support.

@Johan that would work for me, although @JKatzWMF what do you think?

Qgil added a comment.Jun 29 2017, 7:34 AM

When looking for betatesters / early adopters, would it make sense to ask in wikitech-ambassadors? This in itself would be an exercise of explaining the feature and its rationale, and registering initial interest.

@Johan that would work for me, although @JKatzWMF what do you think?

Makes sense to me. Thanks!

Thanks @JKatzWMF - also, what do you think about the suggestion from @Qgil on wikitech-ambassadors for identification of interested early adopter wikis (i.e., those beyond mediawiki.org and wikitech.wikimedia.org)? Any parameters about how you'd want that positioned on wikitech-ambassadors if wikitech-ambassadors makes sense to you?

@Johan @bd808 @Tgr @Anomie would you feel comfortable trying to do a CL-led announcement that it'll be coming to wikitech.wikimedia.org and mediawiki.org, followed by deploying it there? I want us to be mindful of there being operational support in case of bugs; I for one have some vacation next week and part of the week following it (and wouldn't be a useful bug squasher, anyway).

I want us to be mindful of there being operational support in case of bugs

I have vacation the week of July 10-14 and the weeks of July 31-August 11.

bd808 added a comment.Jun 29 2017, 9:30 PM

[...] @bd808 [...] would you feel comfortable trying to do a CL-led announcement that it'll be coming to wikitech.wikimedia.org and mediawiki.org, followed by deploying it there?

There's really no community to warn on wikitech to speak of. We could announce on labs-l/wikitech-l/ops-l before or after the rollout. The early adopters would probably be me, Quiddity, and maybe Krinkle. We could try moving the styles for mbox/ambox into using it to give an initial test.

When looking for betatesters / early adopters, would it make sense to ask in wikitech-ambassadors? This in itself would be an exercise of explaining the feature and its rationale, and registering initial interest.

(My2c) Generally speaking I'd rather keep this option for when we have no options, or need to encourage multiple wikis to volunteer. In this phase we could probably find the 2 candidates we need without bothering hundreds of people. Every message we send out has a cost in terms of attention.

Johan added a subscriber: Nirmos.Jul 3 2017, 3:47 AM

Relevant: See @Nirmos' comment in T168808#3399400.

dr0ptp4kt moved this task from Backlog to Adam Radar on the Reading-Admin board.Jul 20 2017, 9:33 PM
Johan moved this task from Backlog to Keep track of on the User-Johan board.Jul 26 2017, 3:23 AM
Anomie moved this task from Up next to Non-code on the TemplateStyles board.Sep 19 2017, 10:27 PM
Qgil added a comment.Oct 4 2017, 9:04 AM

What is left to complete this task? It is not clear.

This task has been languishing and changing of hands. I for one would welcome a clearer description of this Readers-Community-Engagement request including the details suggested at https://phabricator.wikimedia.org/T157446

Deskana added a subscriber: Deskana.Nov 1 2017, 1:04 PM

Dan and I spoke today. Here's a suggested (rough) plan. Open to suggestions and feedback.

There are currently two related tasks that need to be addressed.
First is restricting the feature to the Template: namespace. Creating Yet Another Standard (xkcd) on how to style content that is not a template could cause confusion down the road. T176269

Second is being prepared, in case of some emergency, that we have a quick way to deactivate the feature. Un-deploying extensions is a known process, but is more complicated than making a relatively simple configuration change. T176268

Meta wiki seems like a logical contender for the next non-content wiki. However the initial discussion was short and the community there would need to be approached again. T170863#3457418

The Swedish Wikipedia is interested in being the first content wiki to have this feature enabled. The conversation (my understanding of Swedish is limited) appears to be positive. T168808#3611698

While the tasks mentioned are being addressed I'll work on drafting an announcement for the Swedish Wikipedia. We'll then approach Swedish (and possibly Meta again) with a conversation about enabling the feature.

Assuming everything goes as anticipated, to build awareness, I'll post announcements to the appropriate talk pages (Village Pumps) and mailing lists to let contributors know of the new feature, reference documentation, and let folks know where to get help.

Additionally, it's recommended that as we work with the communities to enable this feature we use something like a notice on the Template namespace (English Wikipedia example) for a few weeks after enabling the feature to let logged-in contributors know of the feature - in case they miss the initial announcement. This is something I'm happy to help draft, but when possible would love to have community support for enabling.

After Meta and Swedish Wikipedia the Russian Wikipedia has shown interest, albeit with concerns over a particular technical issue. (T168333) If that can be resolved we can approach them next, with perhaps other interested wikis. If there is no clear interested communities we can approach similarly sized projects.

Anomie added a comment.Nov 1 2017, 2:42 PM

There are currently two related tasks that need to be addressed.

Is that "addressed" as in "discussed and potentially rejected", or "addressed" as in "we demand you do this, no matter how bad of an idea it is"?

I'm not demanding anything. Discussed and potentially rejected is a viable method of addressing the outstanding concerns.

CKoerner_WMF updated the task description. (Show Details)Nov 1 2017, 5:36 PM

If you're working on this then it probably doesn't belong to the backlog anymore :)

This comment was removed by Elitre.

I will never be an agile scrum master. :)

CKoerner_WMF raised the priority of this task from Normal to High.
CKoerner_WMF lowered the priority of this task from High to Normal.Dec 22 2017, 6:29 PM
CKoerner_WMF updated the task description. (Show Details)Mar 2 2018, 6:25 PM
atgo added a subscriber: atgo.Mar 29 2018, 11:56 PM
CKoerner_WMF raised the priority of this task from Normal to High.
CKoerner_WMF lowered the priority of this task from High to Normal.
CKoerner_WMF closed this task as Resolved.Jul 2 2018, 3:05 PM

I'm going to resolve this task in favor of a polite request for more specific tasks regarding CL support and Template Styles. :) There's a useful checklist in the task description we can reference going forward.

If ya'll need support for something more specific (like, "Talk to community X about enabling TemplateStyles") then please create a task and we'll give you a hand. :)

Johan moved this task from Keep track of to Archive on the User-Johan board.Jul 22 2018, 2:27 AM
Deskana moved this task from Non-code to Done on the TemplateStyles board.Aug 9 2018, 11:40 AM